# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import pulumi
import pulumi.runtime
from .. import utilities, tables

class Definition(pulumi.CustomResource):
    description: pulumi.Output[str]
    """
    The description of the policy definition.
    """
    display_name: pulumi.Output[str]
    """
    The display name of the policy definition.
    """
    management_group_id: pulumi.Output[str]
    """
    The ID of the Management Group where this policy should be defined. Changing this forces a new resource to be created.
    """
    metadata: pulumi.Output[str]
    """
    The metadata for the policy definition. This
    is a json object representing additional metadata that should be stored
    with the policy definition.
    """
    mode: pulumi.Output[str]
    """
    The policy mode that allows you to specify which resource
    types will be evaluated.  The value can be "All", "Indexed" or
    "NotSpecified". Changing this resource forces a new resource to be
    created.
    """
    name: pulumi.Output[str]
    """
    The name of the policy definition. Changing this forces a
    new resource to be created.
    """
    parameters: pulumi.Output[str]
    """
    Parameters for the policy definition. This field
    is a json object that allows you to parameterize your policy definition.
    """
    policy_rule: pulumi.Output[str]
    """
    The policy rule for the policy definition. This
    is a json object representing the rule that contains an if and
    a then block.
    """
    policy_type: pulumi.Output[str]
    """
    The policy type.  The value can be "BuiltIn", "Custom"
    or "NotSpecified". Changing this forces a new resource to be created.
    """
    def __init__(__self__, __name__, __opts__=None, description=None, display_name=None, management_group_id=None, metadata=None, mode=None, name=None, parameters=None, policy_rule=None, policy_type=None):
        """
        Manages a policy rule definition on a management group or your provider subscription. 
        
        Policy definitions do not take effect until they are assigned to a scope using a Policy Assignment.
        
        
        :param str __name__: The name of the resource.
        :param pulumi.ResourceOptions __opts__: Options for the resource.
        :param pulumi.Input[str] description: The description of the policy definition.
        :param pulumi.Input[str] display_name: The display name of the policy definition.
        :param pulumi.Input[str] management_group_id: The ID of the Management Group where this policy should be defined. Changing this forces a new resource to be created.
        :param pulumi.Input[str] metadata: The metadata for the policy definition. This
               is a json object representing additional metadata that should be stored
               with the policy definition.
        :param pulumi.Input[str] mode: The policy mode that allows you to specify which resource
               types will be evaluated.  The value can be "All", "Indexed" or
               "NotSpecified". Changing this resource forces a new resource to be
               created.
        :param pulumi.Input[str] name: The name of the policy definition. Changing this forces a
               new resource to be created.
        :param pulumi.Input[str] parameters: Parameters for the policy definition. This field
               is a json object that allows you to parameterize your policy definition.
        :param pulumi.Input[str] policy_rule: The policy rule for the policy definition. This
               is a json object representing the rule that contains an if and
               a then block.
        :param pulumi.Input[str] policy_type: The policy type.  The value can be "BuiltIn", "Custom"
               or "NotSpecified". Changing this forces a new resource to be created.
        """
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['description'] = description

        if not display_name:
            raise TypeError('Missing required property display_name')
        __props__['display_name'] = display_name

        __props__['management_group_id'] = management_group_id

        __props__['metadata'] = metadata

        if not mode:
            raise TypeError('Missing required property mode')
        __props__['mode'] = mode

        __props__['name'] = name

        __props__['parameters'] = parameters

        __props__['policy_rule'] = policy_rule

        if not policy_type:
            raise TypeError('Missing required property policy_type')
        __props__['policy_type'] = policy_type

        super(Definition, __self__).__init__(
            'azure:policy/definition:Definition',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

