# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import pulumi
import pulumi.runtime
from .. import utilities, tables

class FirewallRule(pulumi.CustomResource):
    end_ip: pulumi.Output[str]
    """
    The highest IP address included in the range.
    """
    name: pulumi.Output[str]
    """
    The name of the Firewall Rule. Changing this forces a new resource to be created.
    """
    redis_cache_name: pulumi.Output[str]
    """
    The name of the Redis Cache. Changing this forces a new resource to be created.
    """
    resource_group_name: pulumi.Output[str]
    """
    The name of the resource group in which this Redis Cache exists.
    """
    start_ip: pulumi.Output[str]
    """
    The lowest IP address included in the range
    """
    def __init__(__self__, __name__, __opts__=None, end_ip=None, name=None, redis_cache_name=None, resource_group_name=None, start_ip=None):
        """
        Manages a Firewall Rule associated with a Redis Cache.
        
        
        :param str __name__: The name of the resource.
        :param pulumi.ResourceOptions __opts__: Options for the resource.
        :param pulumi.Input[str] end_ip: The highest IP address included in the range.
        :param pulumi.Input[str] name: The name of the Firewall Rule. Changing this forces a new resource to be created.
        :param pulumi.Input[str] redis_cache_name: The name of the Redis Cache. Changing this forces a new resource to be created.
        :param pulumi.Input[str] resource_group_name: The name of the resource group in which this Redis Cache exists.
        :param pulumi.Input[str] start_ip: The lowest IP address included in the range
        """
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not end_ip:
            raise TypeError('Missing required property end_ip')
        __props__['end_ip'] = end_ip

        __props__['name'] = name

        if not redis_cache_name:
            raise TypeError('Missing required property redis_cache_name')
        __props__['redis_cache_name'] = redis_cache_name

        if not resource_group_name:
            raise TypeError('Missing required property resource_group_name')
        __props__['resource_group_name'] = resource_group_name

        if not start_ip:
            raise TypeError('Missing required property start_ip')
        __props__['start_ip'] = start_ip

        super(FirewallRule, __self__).__init__(
            'azure:redis/firewallRule:FirewallRule',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

